Whamcloud - gitweb
Need to package the scripts in $libdir/lustre/.
[fs/lustre-release.git] / lustrecvs
1 #!/bin/sh
2
3 LC_COLLATE="C"
4 progname="${0##*/}"
5
6 warn ()
7 {
8     [ "$1" ] && echo >&2
9     [ "$1" ] && echo "$progname: $1" >&2
10     [ "$1" ] && echo >&2
11 }
12
13 fatal ()
14 {
15     warn "$2"
16     exit "$1"
17 }
18
19 usage ()
20 {
21     cat <<EOF
22 Usage: $progname <lustretag>
23   where <lustretag> is a tag of the lustre-core module
24 EOF
25 }
26
27 if [ -z "$LUSTRECVS_UPDATED" ] ; then
28     echo "$progname: updating lustrecvs"
29     cvs up -l || fatal 1 "Error updating lustrecvs"
30     export LUSTRECVS_UPDATED=yes
31     exec "$0" "$@"
32 fi
33
34 [ "$1" = "-r" ] && shift
35
36 buildtag="HEAD"
37 lustretag="$1"
38 shift
39
40 if [ "$*" ] ; then
41     usage >&2
42     exit 1
43 fi
44
45
46 case "$lustretag" in
47     '')
48         warn "a lustretag is required."
49         usage >&2
50         exit 1
51         ;;
52     --help | -h)
53         usage
54         exit 0
55         ;;
56
57     # These releases did not get build tagged for them because they
58     # this build system didn't exist when they were tagged
59     v1_2_8|v1_4_0) 
60         buildtag="b1_4"
61         ;;
62     
63     b1_4*) buildtag="b1_4" ;;
64
65     b_release_1_4_6-patchless) buildtag="b1_4" ;;
66
67     v* | b_release*) buildtag=$lustretag ;;
68
69     # this is the branch table
70     # keep this list sorted alphabetically!
71
72     *)
73         buildtag="HEAD"
74         ;;
75
76 esac
77
78 error_modules=
79 cvs_cmd ()
80 {
81     dir="$1"
82     module="$2"
83     tag="$3"
84     cotag=""
85     update=""
86
87     if [ "$tag" = "HEAD" ] ; then
88         cotag=""
89         uptag="-A"
90     elif [ "$tag" ] ; then
91         cotag="-r $tag"
92         uptag="-r $tag"
93     else
94         # silently skip if no tag was specified
95         return
96     fi
97
98     if [ -d "$dir" ] ; then
99         echo "$progname: Updating $dir to $tag"
100         ( cd "$dir" && cvs up -dP $uptag )
101     else
102         echo "$progname: Checking out $dir from $tag"
103         cvs co -P $cotag -d "$dir" "$module"
104     fi
105     if [ $? != 0 ] ; then
106         error_modules="$dir $error_modules"
107     fi
108 }
109
110 cvs_cmd build lustre-build "$buildtag"
111
112 if [ -f build/buildcvs ] ; then
113     . build/buildcvs
114 else
115     fatal 1 "build/buildcvs does not exist; not updating other modules."
116 fi
117
118 if [ "$error_modules" ] ; then
119     fatal 1 "There were errors checking out the following directories: $error_modules"
120 fi